//Erick Leon, 2015
//Based off the code by Eli Bendersky http://eli.thegreenplace.net/2011/01/23/how-debuggers-work-part-1.html 
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/reg.h>
#include <sys/user.h>
#include <unistd.h>
#include <errno.h>
#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <signal.h>
#include <syscall.h>
#include <stdint.h>
#include <sys/ptrace.h>
#include <time.h>

void name(const char* programname){
  if(ptrace(PTRACE_TRACEME, 0, 0, 0) < 0){//Trace the program
  perror("ptrace");
  return;
  }
execl(programname, programname, (char *)0);//Name of the program to trace
}

void analyze(pid_t child_pid){
clock_t t;//benchmarking
t=clock();//benchmarking
int calll=0;//updates destiny after call
int i;//for
int counter=0; //counter to manipulate our buffer
FILE *ptr_file; //file storing hex values
uint64_t instr,check,dest,op,op2;//store the hex values of instructions and eip/rip and opcodes
uint64_t bfr[900000]; //our buffer
int wait_status;
wait(&wait_status);//wait for child process to stop at first instruction
  while(WIFSTOPPED(wait_status)){
  struct user_regs_struct regs;//eip or rip
  ptrace(PTRACE_GETREGS, child_pid, 0, &regs);//obtain regs eip or rip
  instr = ptrace(PTRACE_PEEKTEXT, child_pid, regs.rip, 0);//instruction at current rip
    if (calll == 1){//if a call has happened, update destiny
    dest = ptrace(PTRACE_PEEKDATA, child_pid, regs.rsp, 0);//next instruction after call
    bfr[counter]=dest;//store the destination in a buffer
    counter++;//increase to the next position
    }//end of if call has happened
  calll=0;//reset the call counter, i.e. call has NOT happened
  op = instr & 0xff; //opcode for first byte
  op2 = instr & 0xff00; //opcode for second byte, rex.w prefix
    if (op==0xe8 || op==0x9a || op==0xff || op2 == 0xff00){//if opcodes for call
    calll=1;//a call has happened
    //printf("Call at RIP: 0x%lx instruction: 0x%lx\n",regs.rip, instr);
    }//if opcodes for call
    if (op==0xc3 || op==0xcb || op==0xc2 || op==0xca){//if opcodes for ret
    counter--;//decrease position on array
    //ptrace(PTRACE_POKEDATA, child_pid,regs.rsp, 333); //Code injection
    check = ptrace(PTRACE_PEEKDATA, child_pid, regs.rsp, 0);//value in current rsp stack
    //printf("Ret Going to: 0x%lx  Supposed to go to: 0x%lx instruction: 0x%lx\n",check, dest, instr);
    int ii = 0;//if ret has happened
      for(i=counter;i>=0;i--){//check all stored dest
        if(check == bfr[i]){//if next position from call is different from where the rsp stack wants to send me
        ii=1;//if a ret was fine to go
        break;
        }//if check
      }//for i=counter
      if(ii!=1){//if ret was NOT fine to go
      printf("Error! Sends me to=0x%lx Current RIP=0x%lx Instr=0x%lx\n",check,regs.rip,instr);//Shows the problem
      kill(child_pid,SIGKILL); //kill the process
      //Create a file to store the hex values of instr
      ptr_file =fopen("o", "w"); //open file to write
      fprintf(ptr_file,"%lx\n", instr);//write hex values to file
      fclose(ptr_file);//close file
      //End of file creation
      system("./client.py");//Notify the sysadmin
      t=clock()-t;//benchmarking
      printf("INTERNAL: Clicks: %d (%f seconds)\n",t,((float)t)/CLOCKS_PER_SEC);//benchmarking
      exit(0);//end
      }//if ii	
    }//if opcodes for ret
    if(ptrace(PTRACE_SINGLESTEP, child_pid, 0, 0) < 0){//Single step it
    perror("ptrace");
    return;
    }//if singlestep
  wait(&wait_status);//Wait for next stop
  }//while general
}//function

int main(int argc, char** argv){//main
clock_t t;//benchmarking
t=clock();//benchmarking
pid_t child_pid;//child process
  if(argc < 2){
  fprintf(stderr, "Invalid\n");
  return -1;
  }//if argc
child_pid = fork();
  if(child_pid == 0)
  name(argv[1]);
  else if(child_pid > 0)
  analyze(child_pid);
  else{
  perror("fork");
  return -1;
  }//if-else
t=clock()-t;//benchmarking
printf("EXTERNAL: Clicks: %d (%f seconds)\n",t,((float)t)/CLOCKS_PER_SEC);//benchmarking
return 0;
}//main
